import os
import sys

from distutils.command.build import build
from setuptools import setup, Command


version_info = {
    'name': 'strata-sdk',
    'version': '1',
    'description': 'A SDK interface to Strata',
    'author': 'Keith Robertson',
    'author_email': 'kroberts@redhat.com',
    'url': 'https://api.access.redhat.com',
    'license': 'ASL2',
    'classifiers': [
        'Development Status :: 1 - Beta',
        'Environment :: Console',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: ASL2 License',
        'Operating System :: OS Independent',
        'Programming Language :: Python :: 2.6' ],
}


setup(
    package_dir={ '': 'src' },
    packages=[ 'stratasdk.infrastructure', 'stratasdk.utils', 'stratasdk.web', 'stratasdk.xml'],
    py_modules=['stratasdk.api'],
    install_requires=['lxml >= 2.2.8'],
    entry_points={},
    **version_info
)
