'''
Created on Apr 10, 2012

@author: Keith Robertson
'''
import unittest
import ConfigParser
from stratasdk.api import API
from stratasdk.infrastructure.brokers import articles, article

__author__ =  'Keith Robertson <kroberts@redhat.com>'

class Test(unittest.TestCase):

    def setUp(self):
        self.config = ConfigParser.ConfigParser()
        self.config.read('strata.cfg')
        self.user = self.config.get('strata','username')
        self.passwd = self.config.get('strata','password')
        self.url = self.config.get('strata','url')
        pass

    def testGetArticle(self):
        print "---testGetArticle---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=True,
                  verbose=False)
        sid = self.config.get('testGetArticle','artID')
        print "Getting article %s" % sid
        art = api.articles.get(sid)
        print art
        api.disconnect()
        assert art is not None
        print "Article title(%s)" % art.get_title()
        assert art.get_title() == self.config.get('testGetArticle','title')
        print "Article authorSSOName(%s)" % art.get_authorSSOName()
        assert art.get_authorSSOName() == self.config.get('testGetArticle','authorSSOName')
        pass

    def testFilterArticles(self):
        print "---testFilterArticles---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=False,
                  verbose=False)
        artAry = api.articles.list(self.config.get('testFilterArticles','keyword'),
                                   title=self.config.get('testFilterArticles','title'))
        api.disconnect()
        assert artAry is not None and len(artAry) > 0
        for art in artAry:
            print "Found the following article:"
            art.toXml()
        pass

    def testAddUpdateArticle(self):
        print "---testAddUpdateArticle---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=True,
                  verbose=False)

        art = api.im.makeArticle(createdBy='rhn-support-cbredese',
                                 title=self.config.get('testAddUpdateArticle','title'),
                                 summary="Summary text here",
                                 kcsState='wip',
                                 body='Body text here')
        print "---Adding article---"
        art.toXml()
        doc = api.articles.add(art)
        assert doc.get_id() is not None
        print "---Updating article---"
        doc.toXml()
        art.set_body(self.config.get('testAddUpdateArticle','newtext'))
        art.toXml()
        assert art.get_body() == self.config.get('testAddUpdateArticle','newtext')
        art.update()
        api.disconnect()
        pass



if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()
