'''
Created on Apr 10, 2012

@author: Keith Robertson
'''
import unittest
import os
import ConfigParser
from stratasdk.api import API
from stratasdk.infrastructure.brokers import attachments, attachment

__author__ =  'Keith Robertson <kroberts@redhat.com>'

class Test(unittest.TestCase):

    def setUp(self):
        self.config = ConfigParser.ConfigParser()
        self.config.read('strata.cfg')
        self.user = self.config.get('strata','username')
        self.passwd = self.config.get('strata','password')
        self.url = self.config.get('strata','url')
        pass

    def testGetAttachment(self):
        print "---testGetAttachment---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=False,
                  verbose=False)
        caseID = self.config.get('testGetAttachment','caseID')
        uuid = self.config.get('testGetAttachment','uuid')
        fileName = self.config.get('testGetAttachment','fileName')
        dir = self.config.get('testGetAttachment','dir')
        print "Getting attachment %s from case %s" % (caseID, uuid)
        attachment = api.attachments.get(caseID, uuid, fileName, dir)
        api.disconnect()
        assert attachment == os.path.join(dir, fileName)
        # Need to test contents of file.
        pass

    def testFilterAttachments(self):
        print "---testFilterAttachments---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=True,
                  verbose=False)
        caseID = self.config.get('testFilterAttachments','caseID')
        uuid = self.config.get('testFilterAttachments','uuid')
        aAry = api.attachments.list(caseID,
                                    uuid=self.config.get('testFilterAttachments','uuid'))
        api.disconnect()
        assert aAry is not None
        for a in aAry:
            print "Found the following attachment:"
            a.toXml()
            assert a.get_description() == self.config.get('testFilterAttachments','description')
        pass
#
#    def testAddAttachment(self):
#        print "---testAddAttachment---"
#        api = API(username=self.user,
#                  password=self.passwd,
#                  url=self.url,
#                  httpDebug=False,
#                  verbose=False)
#
#        caseID = self.config.get('testAddAttachment','caseID')
#        file = self.config.get('testAddAttachment','file')
#        public = self.config.get('testAddAttachment','public')
#        description = self.config.get('testAddAttachment','description')
#        resp = api.attachments.add(caseID,
#                                   public,
#                                   file,
#                                   description)
#        #resp.toXml()
#        api.attachments.delete(resp.caseNumber, resp.uuid)
#        api.disconnect()
#        pass



if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()
