'''
Created on Apr 10, 2012

@author: Keith Robertson
'''
import unittest
import ConfigParser
from xml.sax.saxutils import escape
from stratasdk.api import API
from stratasdk.infrastructure.brokers import problems, problem
from stratasdk.xml.params import link

__author__ =  'Keith Robertson <kroberts@redhat.com>'

class Test(unittest.TestCase):

    def setUp(self):
        self.config = ConfigParser.ConfigParser()
        self.config.read('strata.cfg')
        self.user = self.config.get('strata','username')
        self.passwd = self.config.get('strata','password')
        self.url = self.config.get('strata','url')
        pass

    def testStringDiagnose(self):
        print "---testStringDiagnose---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=False,
                  verbose=False)
        # FIXME make me do something useful.
        # check that HTTP upload is escaped by broker.
        pary = api.problems.diagnoseStr('Exception: This failure intentionally triggered < > ')
        api.disconnect()
        for p in pary:
            lary = p.get_link()
            for l in lary:
                print l.get_uri()
                print l.get_value()        
        pass

    def testFileDiagnose(self):
        print "---testFileDiagnose---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=False,
                  verbose=False)
        # FIXME make me do something useful.
        # check that HTTP upload is escaped by broker.
        pary = api.problems.diagnoseFile('./content.xml')
        api.disconnect()
        for p in pary:
            lary = p.get_link()
            for l in lary:
                print l.get_uri()
                print l.get_value()      
        pass




if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()
