'''
Created on Apr 10, 2012

@author: Keith Robertson
'''
import unittest
import ConfigParser
from stratasdk.api import API
from stratasdk.infrastructure.brokers import solutions, solution

__author__ =  'Keith Robertson <kroberts@redhat.com>'

class Test(unittest.TestCase):

    def setUp(self):
        self.config = ConfigParser.ConfigParser()
        self.config.read('strata.cfg')
        self.user = self.config.get('strata','username')
        self.passwd = self.config.get('strata','password')
        self.url = self.config.get('strata','url')
        pass

    def testGetSolution(self):
        print "---testGetSolution---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=False,
                  verbose=False)
        sid = self.config.get('testGetSolution','solutionID')
        print "Getting solution %s" % sid
        sol = api.solutions.get(sid)
        print sol
        api.disconnect()
        assert sol is not None
        print "Solution title(%s)" % sol.get_title()
        assert sol.get_title() == self.config.get('testGetSolution','title')
        print "Solution authorSSOName(%s)" % sol.get_authorSSOName()
        assert sol.get_authorSSOName() == self.config.get('testGetSolution','authorSSOName')
        pass

    def testFilterSolutions(self):
        print "---testFilterSolutions---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=False,
                  verbose=False)
        solAry = api.solutions.list(self.config.get('testFilterSolutions','keyword'),
                                         title=self.config.get('testFilterSolutions','title'))
        api.disconnect()
        assert solAry is not None
        for sol in solAry:
            print "Found the following solution:"
            sol.toXml()
        pass

    def testAddUpdateSolution(self):
        print "---testAddUpdateSolution---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=True,
                  verbose=False)

        sol = solution.fromProps(createdBy='rhn-support-cbredese',
                                 title=self.config.get('testAddUpdateSolution','title'),
                                 summary="testAddUpdateSolution",
                                 kcsState='wip',
                                 resolution='test')
        print "---Adding solution---"
        sol.toXml()
        doc = api.solutions.add(sol)
        assert doc.get_id() is not None
        print "---Updating solution---"
        doc.toXml()
        sol.set_resolution(self.config.get('testAddUpdateSolution','newtext'))
        sol.toXml()
        assert sol.get_resolution().get_text() == self.config.get('testAddUpdateSolution','newtext')
        sol.update()
        api.disconnect()
        pass



if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()
